﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Utility
{
    public class MathHelp
    {
        /// <summary>
        /// 获取运算结果字符串, 再根据需求转换为对应的数字类型
        /// </summary>
        /// <param name="expression">表达式</param>
        public static string MathCalculate(string expression)
        {
            object retvar = MathCalculateFunc(expression);
            if(retvar != null)
            {
                return retvar.ToString();
            }
            return "";
        }

        /// <summary>
        /// 将字符串中的运算符按正常计算 例如按四则运算
        /// </summary>
        /// <param name="expression">标准表达式如 (1+15)*0.5-200</param>
        /// <returns>返回计算的值，可以为任意合法的数据类型</returns>
        private static object MathCalculateFunc(string expression)
        {
            object retvar = null;
            Microsoft.CSharp.CSharpCodeProvider provider = new Microsoft.CSharp.CSharpCodeProvider();
            System.CodeDom.Compiler.CompilerParameters cp = new System.CodeDom.Compiler.CompilerParameters(new string[] { @"System.dll" });
            StringBuilder builder = new StringBuilder("using System;class CalcExp{public static object Calc(){ return \"expression\";}}");
            builder.Replace("\"expression\"", expression);
            string code = builder.ToString();
            System.CodeDom.Compiler.CompilerResults results;
            results = provider.CompileAssemblyFromSource(cp, new string[] { code });
            if (results.Errors.HasErrors)
            {
                retvar = null;
            }
            else
            {
                System.Reflection.Assembly a = results.CompiledAssembly;
                Type t = a.GetType("CalcExp");
                retvar = t.InvokeMember("Calc", System.Reflection.BindingFlags.Public | System.Reflection.BindingFlags.Static | System.Reflection.BindingFlags.InvokeMethod
                    , System.Type.DefaultBinder, null, null);
            }
            return retvar;
        }

    }
}
